using System;
using System.Configuration.Install;
using System.Collections;
using System.ComponentModel;

using System.IO;
using System.Text;

using System.Runtime.InteropServices;

using Microsoft.Win32;

namespace com.macromedia.mesh.Flash
{

	public enum FuFlags : long
	{
		SMTO_NORMAL         = 0x00,
		SMTO_BLOCK          = 0x01,
		SMTO_ABORTIFHUNG    = 0x02
	}

	public enum Win32h : uint
	{
		SMTO_NORMAL         = 0x00,
		SMTO_BLOCK          = 0x01,
		SMTO_ABORTIFHUNG    = 0x02,
		WM_SETTINGCHANGE    = 0x1A,
		HWND_BROADCAST      = 0xFFFF
	}

	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	/// 
	[RunInstaller(true)]
	public class FlashCommandInstaller : Installer
	{
		private string path;
		//private string installPath;
		private RegistryKey rk;
		private const string PATHSEPERATER = ";";

		[DllImport("user32.dll", CharSet=CharSet.Auto)]
		public static extern uint SendMessageTimeout(
			uint hwnd,               // HWND_BROADCAST == all top level
			uint msg,                // WM_SETTINGCHANGE
			IntPtr wParam,           // null
			StringBuilder lParam,    // null probably ok here, or "Environment"
			uint fuFlags,            // SMTO_ABORTIFHUNG
			IntPtr uTimeout,         // 5000 == 5 seconds
			IntPtr lpdwResult        // return value
			);

		public FlashCommandInstaller():base()
		{
			rk = Registry.CurrentUser.OpenSubKey("Environment", true);
			path = (string)rk.GetValue("Path");

			Console.WriteLine("Path : " + path);
		}
		public override void Install(IDictionary savedState)
		{
			base.Install(savedState);

			string TARGETDIR = this.Context.Parameters["TARGETDIR"];

			if(TARGETDIR == null)
			{
				throw new Exception("wrong arguments");
			}

			SetPath(TARGETDIR);
		}

		public override void Commit(IDictionary savedState)
		{
			base.Commit(savedState);
		}

		public override void Rollback(IDictionary savedState)
		{
			base.Rollback(savedState);
		}

		public override void Uninstall(IDictionary savedState)
		{
			base.Uninstall(savedState);

			string TARGETDIR = this.Context.Parameters["TARGETDIR"];

			if(TARGETDIR == null)
			{
				throw new Exception("wrong arguments");
			}

			CleanPath(TARGETDIR);
		}

		public static void Main()
		{
			Console.WriteLine("Usage : installutil.exe Installer.exe ");
		}


		private void SetPath(string installPath)
		{
			if(KeyExists(installPath, path))
			{
				return;
			}

			string delim = "";

			if(!path.EndsWith(PATHSEPERATER))
			{
				delim = PATHSEPERATER;
			}

			string newPath = path + delim + installPath; 
			Console.WriteLine("Writing : " + newPath);

			WritePath(newPath);

			return;
		}

		private void WritePath(string newPath)
		{
			rk.SetValue("Path", newPath);
			rk.Flush();
			BroadcastPathChange();
		}

		private void CleanPath(string installPath)
		{
			if(!KeyExists(installPath, path))
			{
				return;
			}

			string[] pathArr = GetPathArray();
			int len = pathArr.Length;

			if(len == 0)
			{
				return;
			}

			StringBuilder newPath = new StringBuilder();

			for(int i = 0; i < len; i++)
			{

				if(installPath.ToLower().Trim().Equals(pathArr[i].ToLower().Trim()))
				{
					Console.WriteLine("Found match : omitting.");
					continue;
				}

				newPath.Append(pathArr[i]);
				newPath.Append(PATHSEPERATER);
			}

			Console.WriteLine("Writing : " + newPath.ToString());

			WritePath(newPath.ToString());
		}

		private bool KeyExists(string installPath, string path)
		{
			string[] pathArr = GetPathArray();
			int len = pathArr.Length;

			for(int i = 0; i < len; i++)
			{
				if(installPath.ToLower().Trim().Equals(pathArr[i].ToLower().Trim()))
				{
					Console.WriteLine("Found : Key. Exiting");
					return true;
				}
				Console.WriteLine(i + " : " + pathArr[i]);
			}

			return false;
		}

		private string[] GetPathArray()
		{
			char[] d = new char[1];
			d[0] = PATHSEPERATER.ToCharArray()[0];

			return path.Split(d);
		}

		private void BroadcastPathChange()
		{
			IntPtr timeout = new IntPtr(5000L);
			IntPtr result = new IntPtr(0);
			StringBuilder env = new StringBuilder("Environment");

			SendMessageTimeout
				(
				(uint) Win32h.HWND_BROADCAST,
				(uint) Win32h.WM_SETTINGCHANGE,
				IntPtr.Zero,
				env,
				(uint) Win32h.SMTO_ABORTIFHUNG,
				timeout,
				result
				);
		}


	}
}
