using System;
using System.IO;
using com.macromedia.mesh.collections;

namespace com.macromedia.mesh.log
{
	/// <summary>
	/// Summary description for Logger.
	/// </summary>
	public class LoggerManager
	{
		private LoggerArrayList loggerArray;
		string NEWLINE = System.Environment.NewLine;

		public LoggerManager()
		{
			loggerArray = new LoggerArrayList();
		}

		public void Add(Logger log)
		{
			loggerArray.Add(log);
		}

		public void Remove(Logger log)
		{
			loggerArray.Remove(log);
		}

		public void Write(string msg)
		{
			foreach(Logger l in loggerArray)
			{
				l.Write(msg);
				l.Flush();
			}
		}

		public void WriteLine(string msg)
		{
			foreach(Logger l in loggerArray)
			{
				l.WriteLine(msg);
				l.Flush();
			}
		}

		public void Close()
		{
			foreach(Logger l in loggerArray)
			{
				l.Close();
			}
		}

		public void Flush()
		{
			foreach(Logger l in loggerArray)
			{
				l.Flush();
			}
		}

	}
}
