using System;
using System.IO;

namespace com.macromedia.mesh.log
{
	/// <summary>
	/// Summary description for StreamWriterLogger.
	/// </summary>
	public class StreamWriterLogger : Logger
	{
		private StreamWriter sw;

		public StreamWriterLogger(StreamWriter sw)
		{
			this.sw = sw;
		}

		public StreamWriterLogger()
		{
		}

		public StreamWriter StreamWriter
		{
			get
			{
				return sw;
			}
			set
			{
				sw = value;
			}
		}

		public override void Close()
		{
			sw.Close();
		}

		public override void Flush()
		{
			sw.Flush();
		}

		public override void Write(string msg)
		{
			sw.Write(GetDateTimeStamp() +  msg);
		}

		public override void WriteLine(string msg)
		{
			sw.WriteLine(GetDateTimeStamp() +  msg);
		}
	}
}
