using System;
using System.IO;

namespace com.macromedia.mesh.log
{
	/// <summary>
	/// Summary description for ConsoleLogger.
	/// </summary>
	public class TextWriterLogger : Logger
	{
		private TextWriter writer;

		public TextWriterLogger(TextWriter writer)
		{
			this.writer = writer;
		}

		public override void Write(string msg)
		{
			writer.Write(GetDateTimeStamp() + msg);
		}

		public override void WriteLine(string msg)
		{
			writer.WriteLine(GetDateTimeStamp() + msg);
		}

		public override void Flush()
		{
			writer.Flush();
		}

		public override void Close()
		{
			writer.Close();
		}
	}
}