using System;
using System.IO;

namespace com.macromedia.mesh.utils
{
	public class FileUtils
	{
		private FileUtils()
		{
		}

		public static FileInfo GetFile(string filePath)
		{
			return FileUtils.GetFile(new FileInfo(filePath));
		}

		public static FileInfo GetFile(FileInfo file)
		{
			if(!file.Directory.Exists)
			{
				file.Directory.Create();
			}

			if(!file.Exists)
			{
				file.Create();
			}

			return file;
		}

		public static DirectoryInfo CreateDirectoryFromFileName(string fileName)
		{
			DirectoryInfo di = new FileInfo(fileName).Directory;

			if(!di.Exists)
			{
				di.Create();
			}

			return di;
		}

		public static string ChangeExtension(string path, string extension)
		{
			return Path.ChangeExtension(path, extension);
		}

		public static FileInfo ChangeExtension(FileInfo fi, string extension)
		{
			return new FileInfo(Path.ChangeExtension(fi.FullName, extension));
		}

		public static string GetURI(FileInfo f)
		{
			Uri uri = new Uri(f.FullName);
			return uri.ToString();
		}
	}
}
